package nc.itf.hr.wa;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.dao.DAOException;
import nc.vo.bd.ref.RefInfoVO;
import nc.vo.hr.infoset.InfoItemVO;
import nc.vo.hr.tools.pub.GeneralVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.uif2.LoginContext;
import nc.vo.wa.grade.AggWaGradeVO;
import nc.vo.wa.grade.CrtVO;
import nc.vo.wa.grade.PsnhiHeaderVO;
import nc.vo.wa.grade.WaCriterionVO;
import nc.vo.wa.grade.WaGradeVerVO;
import nc.vo.wa.grade.WaPsnhiBVO;
import nc.vo.wa.grade.WaStdHiSetVO;
import nc.vo.wa.item.WaItemVO;

/**
 * нʱ׼òѯ
 * 
 * @author: xuhw
 * @date: 2009-11-11 02:17:10
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public interface IWaGradeQueryService
{
	/**
	 * ѯнʹ<BR>
	 * <BR>
	 * 
	 * @param context
	 * @return WaGrade[]
	 * @throws BusinessException
	 */
	public Object[] queryWaGradeVO(LoginContext context, String strCondition) throws BusinessException;

	/**
	 * ѯнʱ׼ָ
	 * 
	 * @param clsPk
	 *            
	 * @param isMult
	 *            Ƿѡ
	 *            @param strOtherCondition - Ϊַʽ, 1ѯЧ־нʱ׼ 2ݰ汾PKѯнʱ׼
	 * @exception BusinessException
	 *                쳣˵
	 */
	public CrtVO[] queryCriterionByClassid(String clsPk, String strOtherCondition,boolean isMult) throws BusinessException;

	/**
	 * ͨkeyؾۺVO
	 * 
	 * @param strPkWaGrd
	 * @exception BusinessException
	 *                쳣˵
	 */
	public AggWaGradeVO queryAggWagradeByGrdPK(String strPkWaGrd) throws BusinessException;

	/**
	 * нʱ׼ȡԱ
	 * 
	 * @author xuhw on 2009-12-7
	 * @param key
	 * @return
	 * @throws BusinessException
	 */
	public PsnhiHeaderVO[] findPsnHiByStdPK(String strGrdPk) throws BusinessException;

	/**
	 * нʱ׼ȡùĿϢ
	 * @param strGrdPk
	 * @return
	 * @throws BusinessException
	 */
	public WaItemVO getItemVOByGrdPk(String strGrdPk) throws BusinessException;
	/**
	 * нʱ׼ȡнԱֵ趨
	 * 
	 * @author xuhw on 2009-12-7
	 * @param key
	 * @return
	 * @throws BusinessException
	 */
	public WaStdHiSetVO[] queryStdHiByGrdPk(String key, int classType) throws BusinessException;
	
	/**
	 * нʱ׼ȡнԱֵ趨
	 * 
	 * @author xuhw on 2009-12-7
	 * @param key
	 * @return
	 * @throws BusinessException
	 */
	public WaPsnhiBVO[] queryWaPsnhiBVOsByGrdPk(String key, int classType) throws BusinessException;

	/**
	 * нʱ׼ֵ ѯ
	 * 
	 * @author xuhw on 2009-12-7
	 * @param key
	 * @param bo
	 * @return
	 * @throws nc.vo.pub.BusinessException
	 */
	public WaCriterionVO findCriterionByCrtKey(String key, boolean bo) throws nc.vo.pub.BusinessException;

	/**
	 * нʱ׼ֵ ѯ ¼
	 * 
	 * @author xuhw on 2009-12-7
	 * @param key
	 * @param bo
	 * @return
	 * @throws nc.vo.pub.BusinessException
	 */
	public WaCriterionVO[] findCriterionByGrdKey(String key, boolean bo) throws nc.vo.pub.BusinessException;

	/**
	 * ѯϢ
	 * 
	 * @author xuhw on 2010-4-17
	 * @param tableCode
	 * @param infoCode
	 * @return
	 * @throws BusinessException
	 */
	public InfoItemVO queryInfoItemByInf(String tableCode, String infoCode) throws BusinessException;

	/**
	 * ѯϢ
	 */
	public Map<String, RefInfoVO> queryBdRefInfoList() throws BusinessException;
	
	/**
	 * ѯöϢ
	 */
	public GeneralVO[] queryBdEnumValues(String strPk) throws BusinessException;
	
	   /**
     * ȡЧнʱ׼汾
     * @param strGrdPk
     * @param strPKGradever
     * @param isMult
     * @return
     * @throws BusinessException
     */
    public WaGradeVerVO queryEffectGradeVerVO(String strGrdPk,String strPKGradever ,boolean isMult) throws BusinessException;
    
    /**
     * ȡЧнʱ׼汾
     * @param strGrdPk
     * @param strPKGradever
     * @param isMult
     * @return
     * @throws BusinessException
     */
    public WaGradeVerVO queryEffectOrCurrentGradeVerVO(String strGrdPk,String strPKGradever ,boolean isMult) throws BusinessException;
    
    /**
     * ѯнʱ׼ֵ
     * @author xuhw on 2009-11-28
     * @param clsPk
     * @param isMultSec
     * @return
     * @throws BusinessException
     */
    public WaCriterionVO[] queryByClsPk(String clsPk, boolean isMultSec, int sortTpye) throws BusinessException;

    /**
     * нʱ׼ֵ ѯ
     * 
     * @author xuhw on 2009-12-7
     * @param strCrtkey
     * @return
     * @throws DAOException
     */
    public WaCriterionVO queryCriterionVOByCrtKey(String strCrtkey) throws BusinessException;
    
    /**
     * //20150902 shenliangc SONAR⣬ְͶӦְбͳһѯ
     * @param pk_joblevel
     * @return
     * @throws BusinessException
     */
    public HashMap<String, String> queryJoblevelsysNameByJoblevelPk()throws BusinessException;
    
    /**
     * ѯнʱ׼ѾЩ֯
     * @param pk_wa_grade
     * @return
     * @throws BusinessException
     */
    public List<String> queryWaGradeOrg(String pk_wa_grade)throws BusinessException;
    
    /**
     * ѯнʱ׼Ч
     * @param pk_wa_gradever
     * @return
     * @throws BusinessException
     */
    public WaGradeVerVO queryWaGradeVerVO(String pk_wa_gradever)throws BusinessException;
    
    /**
     * ѯӦнʱ׼
     * @param strCondition
     * @return
     * @throws BusinessException
     */
    public String queryWaGradePK(String strCondition)throws BusinessException;
    
    /**
     * ѯϼн
     * @param pkWaPrmlv
     * @return
     * @throws BusinessException
     */
    public String queryParentPrml(String pkWaPrmlv)throws BusinessException;
    
    /**
     * ѯǷѴڸ
     * @param pkWagradeTop
     * @param standard_type
     * @param pkWagrade
     * @return
     * @throws BusinessException
     */
    public UFBoolean checkWaGrade(String pkWagradeTop,String standard_type,String pkWagrade)throws BusinessException;
}
