
package nccloud.hrkq.hrkq.monthottimevo.action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONArray;

import nc.bs.logging.Logger;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.pf.pub.util.SQLUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pubapp.pattern.pub.Constructor;
import nccloud.base.exception.ExceptionUtils;
import nccloud.dto.baseapp.querytree.dataformat.QueryTreeFormatVO;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.querytemplet.QueryUtil4NCC;
import nccloud.framework.web.ui.pattern.grid.Grid;
import nccloud.framework.web.ui.pattern.grid.GridOperator;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.bean.PageQueryVO;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.CommonUtil;
import nccloud.itf.hrkq.hrkq.IMonthottimevoMaintain;
import nccloud.web.hr.pub.HRNccQueryHelper;
import nccloud.web.hrkq.common.utils.AttendDataUtil;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * бѯѯ
 * @version  @since v3.5.6-1903
 */
public class MonthOtTimeVOQueryListAction implements ICommonAction {

  @Override
  public Object doAction(IRequest paramIRequest) {
    PageQueryVO page = null;
    QueryTreeFormatVO queryParam = this.getQueryParam(paramIRequest);
    String busiaction = paramIRequest.getRequestJsonVO().getSysParamJson().getBusiaction();
    try {
      // 1 ȡscheme
      IQueryScheme scheme = this.getScheme(queryParam);
      // 2÷,ȡVOϢ(ƽ̨ĬɷЧ⣬ʵҪĵ)
//      AggMonthOtTimeVO[] aggvos =
//          CommonUtil.getMaintainService().query(scheme);
      List<String> pkList;
      String pkGroup = SessionContext.getInstance().getClientInfo().getPk_group();
      String userId = SessionContext.getInstance().getClientInfo().getUserid(); 
      String whereSql = scheme.getWhereSQLOnly();
      IMDPersistenceQueryService service = CommonUtil.getMDQueryService();
      PsnJobVO psnjobVO = AttendDataUtil.queryPsnJob(null);
      String pk_psndocSql = " (pk_psndoc = '"+psnjobVO.getPk_psndoc()+"' or billmaker ='"+userId+"') and isnull(dr,0) = 0 order by creationtime desc";
      if(busiaction.indexOf("¼Ӱ") >= 0) {
    	  IMonthottimevoMaintain serviceMaintain = CommonUtil.getMaintainService();
    	  //Ȩ޵Ĳ
//    	  List<String> deptList = serviceMaintain.getPowerDeptMap(userId, pkGroup, SessionContext.getInstance().getAppcode());
    	  String sql = "select  c.pk_org as pk_org\n" +
					"          from sm_user a\n" + 
					"         inner join sm_user_role b\n" + 
					"            on a.cuserid = b.cuserid\n" + 
					"         inner join sm_subject_org c\n" + 
					"            on b.pk_role = c.subjectid\n" + 
					"         inner join org_dept d\n" + 
					"            on c.pk_org = d.pk_dept\n" + 
					"         inner join sm_role e\n" + 
					"            on b.pk_role = e.pk_role\n" + 
					"         where   a.cuserid = '"+userId+"'";
    	  
//    	  if(deptList != null && deptList.size() > 0) {
//    		  pk_psndocSql = SQLUtil.buildSqlForIn("pk_dept",deptList.toArray(new String[0])) + " and isnull(dr,0) = 0 order by creationtime desc";
    		  pk_psndocSql = " pk_dept in("+sql+")" + " and isnull(dr,0) = 0 order by creationtime desc";
//    	  }
      } else {
    	  
      }
      String wheresql2 = whereSql != null && whereSql.length() > 0 ? whereSql + " and "+ pk_psndocSql : pk_psndocSql;
      Collection<AggMonthOtTimeVO> bills2 =
          service.queryBillOfVOByCond(AggMonthOtTimeVO.class, wheresql2, false,
              false);
      AggMonthOtTimeVO[] aggvos = bills2.toArray(new AggMonthOtTimeVO[0]);
      // ѯ(scheme);
      if ((aggvos != null) && (aggvos.length > 0)) {
        // 3ҳ
        String[] pks = this.getPks(aggvos);
        AggMonthOtTimeVO[] bills =
            this.getDefaulePageBill(queryParam, aggvos);
        page = new PageQueryVO(pks, bills);
      }
      else {
        page = this.createNullPage();
      }
    }
    catch (BusinessException ex) {
      // 쳣Ϣ
      Logger.error(ex);
      ExceptionUtils.wrapException(ex);
    }
    // תgridϢǰ
    return this.transPageInfoToGrid(page, queryParam, queryParam.getPageCode());
  }

  /**
   * תGridϢ
   *
   * @param pagevo
   * @param pageSize
   * @param pagecode
   * @return
   */
  private Grid covert(PageQueryVO pagevo, int pageSize, String pagecode) {
    AggMonthOtTimeVO[] bills =
        (AggMonthOtTimeVO[]) pagevo.getCurrentPageBills();

    Grid grid = null;
    if (bills != null) {
      int size = bills.length > pageSize ? pageSize : bills.length;
      Object[] heads = new Object[size];

      for (int i = 0; i < size; i++) {
        heads[i] = bills[i].getParent();
      }
      GridOperator operator = new GridOperator(pagecode);
      grid = operator.toGrid(heads);
      grid.getModel().setAllpks(pagevo.getPks());
    }
    return grid;
  }

  /**
   * ҳϢ
   *
   * @return
   */
  private PageQueryVO createNullPage() {
    String[] ids = new String[0];
    AggMonthOtTimeVO[] bills =
        Constructor.construct(AggMonthOtTimeVO.class, 0);
    PageQueryVO page = new PageQueryVO(ids, bills);
    return page;
  }

  /**
   * Ĭҳ
   *
   * @param info
   * @param aggvos
   * @return
   */
  private AggMonthOtTimeVO[] getDefaulePageBill(QueryTreeFormatVO info,
      AggMonthOtTimeVO... aggvos) {
    String pageSizeStr = info.getPageInfo().getPageSize();
    int pageSize = 10;
    if ((pageSizeStr != null) && (pageSizeStr.length() > 0)) {
      pageSize = Integer.parseInt(pageSizeStr);
    }
    info.getPageInfo().setPageIndex("0");
    List<AggMonthOtTimeVO> billLst = new ArrayList<AggMonthOtTimeVO>();
    for (int i = 0; (i < aggvos.length) && (i < pageSize); i++) {
      AggMonthOtTimeVO bill = new AggMonthOtTimeVO();

      bill.setParent(aggvos[i].getParent());
      billLst.add(bill);
    }
    return billLst.toArray(new AggMonthOtTimeVO[0]);
  }

  /**
   * ȡϢ
   *
   * @param aggvos
   * @return
   */
  private String[] getPks(AggMonthOtTimeVO... aggvos) {
    List<String> pks = new ArrayList<String>();
    for (AggMonthOtTimeVO bill : aggvos) {
      pks.add(bill.getPrimaryKey());
    }
    return pks.toArray(new String[0]);
  }

  /**
   * ȡѯ
   *
   * @param paramIRequest
   * @return
   */
  private QueryTreeFormatVO getQueryParam(IRequest paramIRequest) {
    String strRead = paramIRequest.read();
    QueryTreeFormatVO queryParam =
        JsonFactory.create().fromJson(strRead, QueryTreeFormatVO.class);
    return queryParam;
  }

  /**
   * ȡѯ
   *
   * @param queryParam
   * @return
   */
  private IQueryScheme getScheme(QueryTreeFormatVO queryParam) {
    QueryUtil4NCC queryutil = new QueryUtil4NCC(queryParam);
    IQueryScheme scheme = queryutil.convertCondition();
    return scheme;
  }

  /**
   * ҳ
   *
   * @param pageInfo
   * @param length
   * @return
   */
  private int getTotalPage(nccloud.framework.web.ui.model.PageInfo pageInfo,
      int length) {
    int size = pageInfo.getPageSize();
    int total = 0;
    if ((length % size) == 0) {
      total = length / size;
    }
    else {
      total = (length / size) + 1;
    }
    return total;
  }

  /**
   * ҳ
   *
   * @param retObj
   * @param pagevo
   * @param pageSize
   * @param pageIndex
   * @return
   */
  private Object pageSet(Object retObj, PageQueryVO pagevo, int pageSize,
      int pageIndex) {
    Grid grid = null;
    if ((retObj instanceof Grid)) {
      grid = (Grid) retObj;
    }

    nccloud.framework.web.ui.model.PageInfo pageInfo =
        new nccloud.framework.web.ui.model.PageInfo();
    pageInfo.setTotal(pagevo.getPks().length);
    pageInfo.setPageSize(pageSize);
    pageInfo.setPageIndex(pageIndex);
    pageInfo.setTotalPage(this.getTotalPage(pageInfo, pagevo.getPks().length));

    grid.getModel().setPageinfo(pageInfo);
    return grid;
  }

  /**
   * pageϢתǰҪgridģ
   *
   * @param pagevo
   * @param info
   * @param pagecode
   * @return
   */
  private Object transPageInfoToGrid(PageQueryVO pagevo,
      QueryTreeFormatVO info, String pagecode) {
    Object grid = null;
    int pageSize = Integer.parseInt(info.getPageInfo().getPageSize());
    int pageIndex = Integer.parseInt(info.getPageInfo().getPageIndex());
    if (pagevo != null) {
      if (pagevo.getCurrentPageBills().length == 0) {
        return null;
      }
      grid = this.covert(pagevo, pageSize, pagecode);

      grid = this.pageSet(grid, pagevo, pageSize, pageIndex);
    }
    return grid;
  }
}
