
package nccloud.hrkq.hrkq.monthottimevo.hrkq.bean;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import nc.vo.pubapp.pagination.PaginationQueryVO;
import nc.vo.pubapp.pattern.model.entity.bill.IBill;

/**
 * ݷҳѯ
 */
public class PageQueryVO implements Serializable {

  /**
   * ÿҳĵ
   */
  public static final String RECORD_IN_PAGE = "recordInPage";

  private static final long serialVersionUID = 761548308850627487L;

  /**
   * ǰҳĵʵ飨ֻеһʵб壩
   */
  private IBill[] currentPageBills;

  /**
   * ǰѯе
   */
  private String[] pks;

  /**
   * ݷҳѯ캯
   *
   * @param pks ǰѯе
   * @param bills ǰҳĵʵ飨ֻеһʵб壩
   */
  public PageQueryVO(String[] pks, IBill[] bills) {
    this.pks = pks;
    this.currentPageBills = bills;
  }

  /**
   * ȡǰҳĵʵ飨ֻеһʵб壩
   *
   * @return ǰҳĵʵ飨ֻеһʵб壩
   */
  public IBill[] getCurrentPageBills() {
    return this.currentPageBills;
  }

  /**
   * ȡǰѯе
   *
   * @return ǰѯе
   */
  public String[] getPks() {
    return this.pks;
  }

  /**
   * תΪƽ̨ķҳVO
   *
   * @return ƽ̨ķҳVO
   */
  public PaginationQueryVO toPaginationQueryVO() {
    PaginationQueryVO vo = new PaginationQueryVO();
    Map<String, Object> billmap = new HashMap<String, Object>();
    for (IBill bill : this.currentPageBills) {
      billmap.put(bill.getPrimaryKey(), bill);
    }
    vo.setAllpks(this.pks);
    vo.setBillmap(billmap);
    return vo;
  }

}
